/* CYGNUS LOCAL -- meissner/d10v abi change */
/* Definitions of target machine for Mitsubishi D10V.
   Copyright (C) 1999 Free Software Foundation, Inc.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA. */

/* Variables to hold compare operators until the appropriate branch or scc
   operation is done.  */
extern struct rtx_def *compare_op0;
extern struct rtx_def *compare_op1;

/* Functions defined in d10v.c.  */
extern void override_options PROTO((void));
#ifdef TREE_CODE
extern void encode_section_info PROTO((tree));
#endif
#ifdef RTX_CODE
extern int  gpr_operand PROTO((rtx, enum machine_mode));
extern int  accum_operand PROTO((rtx, enum machine_mode));
extern int  reg_or_0_operand PROTO((rtx, enum machine_mode));
extern int  arith16_operand PROTO((rtx, enum machine_mode));
extern int  arith_4bit_operand PROTO((rtx, enum machine_mode));
extern int  arith_nonnegative_operand PROTO((rtx, enum machine_mode));
extern int  arith32_operand PROTO((rtx, enum machine_mode));
extern int  arith64_operand PROTO((rtx, enum machine_mode));
extern int  arith_lower0_operand PROTO((rtx, enum machine_mode));
extern int  ldi_shift_operand PROTO((rtx, enum machine_mode));
extern int  pc_or_label_operand PROTO((rtx, enum machine_mode));
extern int  short_memory_operand PROTO((rtx, enum machine_mode));
extern int  cond_move_operand PROTO((rtx, enum machine_mode));
extern int  cond_exec_operand PROTO((rtx, enum machine_mode));
extern int  carry_operand PROTO((rtx, enum machine_mode));
extern int  f0_operand PROTO((rtx, enum machine_mode));
extern int  f1_operand PROTO((rtx, enum machine_mode));
extern int  f_operand PROTO((rtx, enum machine_mode));
extern int  f0_compare_operator PROTO((rtx, enum machine_mode));
extern int  compare_operator PROTO((rtx, enum machine_mode));
extern int  equality_operator PROTO((rtx, enum machine_mode));
extern int  signed_compare_operator PROTO((rtx, enum machine_mode));
extern int  unsigned_compare_operator PROTO((rtx, enum machine_mode));
extern int  unary_parallel_operator PROTO((rtx, enum machine_mode));
extern int  binary_parallel_operator PROTO((rtx, enum machine_mode));
extern int  extend_parallel_operator PROTO((rtx, enum machine_mode));
extern int  minmax_parallel_operator PROTO((rtx, enum machine_mode));
#endif
extern int  parallel_ldi PROTO((HOST_WIDE_INT));
#ifdef RTX_CODE
extern int  adjacent_memory_operands PROTO((rtx, rtx, rtx));
extern void d10v_expand_divmod PROTO((rtx *, int));
extern void initialize_trampoline PROTO((rtx, rtx, rtx));
extern int  emit_comparison PROTO((enum rtx_code, rtx, rtx, rtx, rtx,
				   enum machine_mode, int));
extern int  select_cc_mode PROTO((enum rtx_code, rtx, rtx));
extern rtx  expand_comparison PROTO((enum rtx_code, rtx, rtx, rtx*));
extern char *emit_move_word PROTO((rtx, rtx, rtx));
extern char *emit_move_2words PROTO((rtx, rtx, rtx));
extern char *emit_move_4words PROTO((rtx, rtx, rtx, rtx, rtx));
extern char *emit_add PROTO((rtx *, rtx));
extern char *emit_subtract PROTO((rtx *, rtx));
extern char *emit_cond_move PROTO((rtx *, rtx));
extern rtx  d10v_split_logical_op PROTO((rtx *, enum rtx_code));
extern void d10v_output_addr_const PROTO((FILE *, rtx));
extern void print_operand_address PROTO((FILE *, rtx));
extern void print_operand PROTO((FILE *, rtx, int));
#ifdef TREE_CODE
extern void init_cumulative_args PROTO((CUMULATIVE_ARGS *, tree, rtx, int,
					int));
#endif
#endif
#ifdef TREE_CODE
extern int  function_arg_boundary PROTO((enum machine_mode, tree));
#ifdef RTX_CODE
extern rtx  function_arg PROTO((CUMULATIVE_ARGS *, enum machine_mode, tree,
				int));
#endif
extern int  function_arg_callee_copies PROTO((CUMULATIVE_ARGS *,
					      enum machine_mode, tree, int));
extern void function_arg_advance PROTO((CUMULATIVE_ARGS *, enum machine_mode,
					tree, int));
extern void setup_incoming_varargs PROTO((CUMULATIVE_ARGS *, enum machine_mode,
					  tree, int *, int));
#ifdef RTX_CODE
extern rtx d10v_expand_builtin_saveregs PROTO((void));
#endif
#endif
#ifdef RTX_CODE
extern int  d10v_legitimate_address_p PROTO((enum machine_mode, rtx, int));
extern rtx  d10v_legitimize_address PROTO((rtx, rtx, enum machine_mode, int));
extern int  d10v_mode_dependent_address_p PROTO((rtx));
extern rtx  d10v_subword PROTO((rtx, int, enum machine_mode,
				enum machine_mode));
#endif
extern d10v_stack_t *d10v_stack_info PROTO((void));
extern void debug_stack_info PROTO((d10v_stack_t *));
extern int  direct_return PROTO((void));
extern void function_prologue PROTO((FILE *, int));
extern void function_epilogue PROTO((FILE *, int));
/* END CYGNUS LOCAL -- meissner/d10v abi change */
